/*
 * g364.c
 * G364 video adapter functions
 *
 * Copyright (C) 1995 by Luc Beurton <Luc.Beurton@fnet.fr>
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License. See the file COPYING in the main directory of this archive for more
 * details.
 */
#include <hdw/g364_def.h>

unsigned int G364_Table[2][7]={
/*  {0x12,0x20,0x100,0x5b,0x36,0x600,0x14a},*/
  {0x19,0x22,0x100,0x4e,0x46,0x600,0x164},
  {0x1a,0x28,0x140,0x6b,0x46,0x800,0x1aa}
};



/*--- Control Registers A ---*/
int G364_SWITCHOFF_VTG(void)
{
  unsigned int ctrl_a,addr;
  addr= G364_CTRL_A;
  ctrl_a=(unsigned int)(*((unsigned int*) addr));
  (unsigned int)(*((unsigned int*) addr))=ctrl_a & 0xFFFFFFFE;
  return 0;
}

int G364_SWITCHON_VTG(void)
{
  unsigned int ctrl_a,addr;
  addr= G364_CTRL_A;
  ctrl_a=(unsigned int)(*((unsigned int*) addr));
  (unsigned int)(*((unsigned int*) addr))=ctrl_a+1;
    return 0;
}

/*--- Screen Description Parameters ---*/
int G364_get_display(unsigned int *x,unsigned int *y)
{
    G364_SWITCHOFF_VTG();
    *x=(unsigned int)(*((unsigned int*)G364_Display) & 0x00ffffff) * 4;
    *y=(unsigned int)(*((unsigned int*)G364_VDisplay) & 0x00ffffff) / 2;
    G364_SWITCHON_VTG();
    return 0;
}


int G364_set_display(int tab)
{
    G364_SWITCHOFF_VTG();
    (unsigned int)(*((unsigned int*)G364_Half_Sync))=G364_Table[tab][0];
    (unsigned int)(*((unsigned int*)G364_Back_Porch))=G364_Table[tab][1];
    (unsigned int)(*((unsigned int*)G364_Display))=G364_Table[tab][2];
    (unsigned int)(*((unsigned int*)G364_Short_Display))=G364_Table[tab][3];
    (unsigned int)(*((unsigned int*)G364_VBlank))=G364_Table[tab][4];
    (unsigned int)(*((unsigned int*)G364_VDisplay))=G364_Table[tab][5];
    (unsigned int)(*((unsigned int*)G364_LineTime))=G364_Table[tab][6];
    G364_SWITCHON_VTG();
    return 0;
}

int G364_TOPOFSCREEN(unsigned int t)
{
    (unsigned int)(*((unsigned int*)G364_TopOfScreen))=t;
    return  0;
}

int G364_Reset(void)
{
   (unsigned int)(*((unsigned int*)G364_RESET))=1;
   return 0;
}

