#ifndef __ERROR_H
#define __ERROR_H

typedef enum STATUS {
	ESUCCESS,                      /* Success                   */
	E2BIG,                         /* Arg list too long         */
	EACCES,                        /* No such file or directory */
	EAGAIN,                        /* Try again                 */
	EBADF,                         /* Bad file number           */
        EBUSY,                         /* Device or resource busy   */
	EFAULT,                        /* Bad address               */
	EINVAL,                        /* Invalid argument          */
	EIO,                           /* I/O error                 */
	EISDIR,                        /* Is a directory            */
	EMFILE,                        /* Too many open files       */
        EMLINK,                        /* Too many links            */
	ENAMETOOLONG,                  /* File name too long        */
	ENODEV,                        /* No such device            */
	ENOENT,                        /* No such file or directory */
	ENOEXEC,                       /* Exec format error         */
	ENOMEM,                        /* Out of memory             */
	ENOSPC,                        /* No space left on device   */
	ENOTDIR,                       /* Not a directory           */
        ENOTTY,                        /* Not a typewriter          */
	ENXIO,                         /* No such device or address */
	EROFS,                         /* Read-only file system     */
	} _STATUS;

/*
 * Don't use the errno from <errno.h> since we would run
 * into trouble with the other definitions from that file
 */
extern int errno;

#endif /* __ERRNO_H */
