#ifndef __PATHNAME_H
#define __PATHNAME_H

#include <arc/configuration.h>
#include <arc/types.h>

/*
 * Undocumented - just a rough guess...
 */
typedef UCHAR BOOLEAN;

typedef enum _OPEN_MODE {
    OpenReadOnly,
    OpenWriteOnly,
    OpenReadWrite,
    /*
     * The following enum values are only documented in the "Portable
     * Bootloader Standard" and should therefore only be used on
     * ARC BIOSes for which these functions are known to exist.
     */
    CreateWriteOnly,
    CreateReadWrite,
    SupersedeWriteOnly,
    SupersedeReadWrite,
    OpenDirectory,
    CreateDirectory
} OPEN_MODE;

typedef enum _MOUNT_OPERATION {
    MountLoadMedia,
    MountUnloadMedia,
} MOUNT_OPERATION;

typedef enum _SEEK_MODE {
    SeekAbsolute,
    SeekRelative
} SEEK_MODE;

typedef struct _DIRECTORY_ENTRY {
    ULONG FileNameLength;
    UCHAR FIleAttribute;
    CHAR FileName[32];
} DIRECTORY_ENTRY, *PDIRECTORY_ENTRY;

typedef struct __DISPLAY_STATUS {
    USHORT CursorXPosition;
    USHORT CursorYPosition;
    USHORT CursorMaxXPosition;
    USHORT CursorMaxYPosition;
    USHORT ForegroundColor;
    USHORT BackgroundColor;
    BOOLEAN HighIntensity;
    BOOLEAN Underscored;
    BOOLEAN ReverseVideo;
} _DISPLAY_STATUS, *P_DISPLAY_STATUS;

typedef struct _FILE_INFORMATION {
    LARGE_INTEGER StartingAddress;
    LARGE_INTEGER EndingAddress;
    LARGE_INTEGER CurrentPosition;
    CONFIGURATION_TYPE Type;
    ULONG FileNameLenght;
    UCHAR Attributes;
    CHAR FileName[32];
} FILE_INFORMATION, *PFILE_INFORMATION;

/*
 * Information returned by GetFileInformation()
 */
#define ReadOnlyFile   1
#define HiddenFile     2
#define SystemFile     4
#define ArchiveFile    8
#define DirectoryFile 16
#define DeleteFile    32

#endif /* __PATHNAME_H */
