#ifndef __TYPES_H
#define __TYPES_H

/*
 * Typedefinitions for bootloader.
 */
typedef signed char CHAR;
typedef signed short SHORT;
typedef signed long long LARGE_INTEGER;
typedef signed int LONG;
typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef unsigned int ULONG;
typedef unsigned short WCHAR;
typedef void VOID;

/*
 * The corresponding pointer types
 */
typedef CHAR *PCHAR;
typedef SHORT *PSHORT;
typedef LARGE_INTEGER *PLARGE_INTEGER;
typedef LONG *PLONG;
typedef UCHAR *PUCHAR;
typedef USHORT *PUSHORT;
typedef ULONG *PULONG;
typedef WCHAR *PWCHAR;
typedef VOID *PVOID;
typedef void *PHYSICAL_ADDRESS;

/*
 * Signal() handler stuff
 */
typedef VOID (*SIGNALHANDLER)(ULONG);

/*
 * The usual stuff...
 */
#ifndef NULL
#define NULL (void *)0L
#endif

#endif /* __TYPES_H */
