/*
 * include/hdw/g364_def.h
 * G364 video adapter definitions 
 *
 * Copyright (C) 1995 by Luc Beurton <Luc.Beurton@fnet.fr>
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License. See the file COPYING in the main directory of this archive for more
 * details.
 */
#ifndef __G364_DEF_H
#define __g364_DEF_H

#define G364_VRAM           0xE0800000
#define G364_START          0xE0280000

#define G364_Half_Sync      0xE0280108
#define G364_Back_Porch     0xE0280110
#define G364_Display        0xE0280118
#define G364_Short_Display  0xE0280120
#define G364_VBlank         0xE0280148
#define G364_VDisplay       0xE0280150
#define G364_LineTime       0xE0280158

#define G364_CTRL_A         0xE0280300
#define G364_TopOfScreen    0xE0280400
#define G364_RESET          0xE0380000 

/*--- Control Registers A ---*/
int G364_SWITCHON_VTG(void);
int G364_SWITCHOFF_VTG(void);


/*--- Screen Description Parameters ---*/
int G364_get_display(unsigned int*,unsigned int *);
int G364_Set_display(int);

int G364_TOPOFSCREEN(unsigned int);
int G364_Reset(void);

#endif /* __G364_DEF_H */
