/*
 * include/stand/debugger.h
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 */
#ifndef __DEBUGGER_H
#define __DEBUGGER_H

/*
 * Command strings
 */
#define CMD_BOOT       "boot"
#define CMD_DUMP       "dump"
#define CMD_DUMPTLB    "dumptlb"
#define CMD_FILL       "fill"
#define CMD_PROBE      "probe"
#define CMD_HELP       "help"
#define CMD_NOP        "nop"
#define CMD_QUIT       "quit"
#define CMD_STRINGS    "strings"
#define CMD_CP0REGS    "cp0regs"
#define CMD_DISASM     "disasm"

#define FALSE             0
#define TRUE              1

#define MAXBUFLEN         256

#define SW_BYTE           1
#define SW_HALFWORD       2
#define SW_WORD           4

/*
 * Prototypes
 */
int boot(int argc, char **argv);
int dump(int argc, char **argv);
int dumptlb(int argc, char **argv);
int fill(int argc, char **argv);
int probe(int argc, char **argv);
int strings(int argc, char **argv);
int cp0regs(void);
int dump_cp0r(void);
int quit(int argc, char *argv[]);
int disasm(int argc, char *argv[]);

int debugger(void);

#endif /* __DEBUGGER_H */
