/*
 * include/stand/pathnames.h
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 */
#ifndef PATHNAMES_H
#define PATHNAMES_H

/*
 * Defines default kernel and ramdisk names
 */
#define DEFAULT_PATH  "multi(0)disk(0)fdisk(0)\\"
#define KERNEL_BASENAME "VMLINUX"
#define RAMDISK_BASENAME "RAMDISK"
#define KERNEL_NAME   DEFAULT_PATH KERNEL_BASENAME
#define RAMDISK_NAME  DEFAULT_PATH RAMDISK_BASENAME

/*
 *  pathnames manipulation routine(s)
 */
char* expand_path(char* org, char* default_path);

#endif /* PATHNAMES_H */
