#include <ansidecl.h>
#include <stddef.h>

/*
 * This is a list of all known error numbers.
 */
CONST char *CONST _sys_errlist[] = {
	"Unknown error",			/* ESUCESS */
	"Arg list too long", 			/* E2BIG */
        "Permission denied",                    /* EACCES */
	"Try again", 				/* EAGAIN */
	"Bad file number", 			/* EBADF */
	"Device or resource busy", 		/* EBUSY */
	"Bad address", 				/* EFAULT */
	"Invalid argument", 			/* EINVAL */
	"I/O error", 				/* EIO */
	"Is a directory", 			/* EISDIR */
	"Too many open files", 			/* EMFILE */
	"Too many links", 			/* EMLINK */
	"File name too long", 			/* ENAMETOOLONG */
	"No such device", 			/* ENODEV */
	"No such file or directory", 		/* ENOENT */
	"Exec format error", 			/* ENOEXEC */
	"Out of memory", 			/* ENOMEM */
	"No space left on device", 		/* ENOSPC */
	"Not a directory", 			/* ENOTDIR */
	"Not a typewriter", 			/* ENOTTY */
	"No such device or address", 		/* ENXIO */
	"Read-only file system", 		/* EROFS */
	NULL
};


#define NR_ERRORS ((sizeof (_sys_errlist))/(sizeof(char *))-1)

CONST int _sys_nerr = NR_ERRORS;
