/*
 * lib/expandpath.c
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file COPYING in the main directory of this archive for
 * more details.
 *
 * Copyright (C) by Stoned Elipot <Stoned.Elipot@fnet.fr>
 */
#include <string.h>
#include <stdlib.h>
#include <stand/malloc.h> 
#include <stand/ctype.h>


/*
 * expand_path()
 * try to make the Pandoriens' life easier when
 * dealing with pathnames.
 * 
 *  FIXME: these if...if... are ugly
 */
char* expand_path(char* org, char* default_path)
{
  char* idx, *temp, *subst;
  int len;
  char* retval=org;

  /* if there is a '(' assume it's a complete ARC path - see arc(5) - */
  /* so give up.                                                      */   
  if (!(strchr(org, '(')))
    {
      /* but if there is ':' and no '(' it should be something like       */
      /* 'A:\foo.bar' let's check this out...                             */
      if ((idx = strchr(org, ':')))
	{				
	  for(temp = org, len = 0; 
	      ((isalpha(*temp) && temp != idx)); 
	      temp++, len ++)
	    ;
	  if (temp == idx)       /* ok, there is only letters before the ':' */
	    {
	      /* use temp again, it's previous value is not usefull anymore  */
	      temp = (char*) malloc(len+2); 
	      strncpy(temp, org, len+1);         /* get the 'A' plus the ':' */
	      *(temp + len + 1) = '\0';	
	      subst = getenv(temp);       /* get it's value from environment */
	      free(temp);	    /* poor temp, we nearly don't need it :) */
	      if (subst)       /* ok, 'A:' is out there, so let's do the job */
		{
		  idx++;                     /* idx now points after the ':' */
		  /* compute the len of the final path */
		  len = strlen(subst) + strlen(idx) + 1; 
		  retval =(char*) malloc(len); 
		  strcpy(retval, subst);     /* assemble the substitued path */
		  strcat(retval, idx);	                         /* all done */
		} /* not in the environment, let open() deal with this badly */
	          /* formed path */
	    } /* not only letters before the ':', same punition :) */
	}
      else
	/* so there is nothing special in this path ? Hum, let's throw in the */
	/* default path if not NULL, hoping that the result is ok :) */
	{
	  if (default_path)
	    {
	      len = strlen(default_path) + strlen(org) + 1;
	      retval = (char*)malloc(len);
	      strcpy(retval, default_path);
	      strcat(retval, org);
	    }
	}
    }
  return retval;
}
