/*
 * lib/gets.c
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1995 by Waldorf GMBH
 * written by Ralf Baechle
 */
#include <stand/stdio.h>
#include <arc/pathname.h>
#include <arc/proto.h>

char *gets(char *s)
{
    _STATUS st;
    PCHAR cp;
    ULONG num;
    ULONG n;
    
    cp = s;
    n = 0;
    do {
        st = Read(stdin->fh, cp, 1, &num);
	if (!num)
	  continue;
	switch(*cp)
	  {
	  case '\n':
	  case '\r':
	    *cp = '\0';
	    printf("\n\r");
	    return(s);
	  case '\b':
	    if (n)
	      {
		printf("\b \b");
		cp--;
		n--;
	      }
	    break;
	  default:
	    printf("%c",*cp);
	    cp++;
	    n++;
	  }
      }
    while(1);

    /* NOTREACHED */
    return s;
}
