/*
 * Gluecode to call the ARC BIOS
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1995 by Waldorf GMBH
 * written by Ralf Baechle
 *
 */
#include <asm/asm.h>
#include <asm/mipsregs.h>

#include <arc/types.h>
#include <arc/errno.h>
#include <arc/boot.h>
#include <arc/configuration.h>
#include <arc/memory.h>
#include <arc/misc.h>
#include <arc/pathname.h>

/*
 * The following macros are especially usefull for __asm__
 * inline assembler.
 */
#ifndef __STR
#define __STR(x) #x
#endif
#ifndef STR
#define STR(x) __STR(x)
#endif

#define BIOS(offset,index,returntype,name,params) \
__asm__( \
	".set\tnoreorder\n\t" \
	".set\tnoat\n\t" \
	".globl\t" STR(name) "\n" \
	STR(name)":\n\t" \
	"lw\t$1," STR(__FirmwareCallVector) "\n\t" \
	STR(FILL_LDS)"\n\t" \
	"lw\t$1," STR(offset) "($1)\n\t" \
	"jr\t$1\n\t" \
	"nop\n\t" \
	".set\tat\n\t" \
	".set\treorder\n\t");

#include <arc/proto.h>
