/*
 * Makefile for MIPS Linux main source directory
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1995 by Waldorf GMBH
 * written by Ralf Baechle
 */
#include <arc/types.h>
#include <arc/proto.h>
#include <arc/errno.h>

int setenv(const char *name, const char *value, int overwrite)
{
    _STATUS st;

    if(overwrite == 0)
    {
        if(GetEnvironmentVariable((const PCHAR)name) != NULL)
	{
            return 0;
	}
    }
    st = SetEnvironmentVariable((const PCHAR)name, (const PCHAR)value);
    if(st != ESUCCESS)
    {
        errno = st;
        return -1;
    }

    return 0;
}
