divert(-1)dnl
#
# m4 file for generation of milo and pandora manual pages
# 
# man pages written by Ralf Baechle (ralf@waldorf-gmbh.de),
#
# m4'ification by lazy :) Stoned Elipot (Stoned.Elipot@fnet.fr).
#
# Some useful macros - from GNU m4 manual
define(`upcase', `translit(`$*', `a-z', `A-Z')')dnl
define(`downcase', `translit(`$*', `A-Z', `a-z')')dnl
define(`capitalize1',`regexp(`$1', `^\(\w\)\(\w*\)', `upcase(`\1')`'downcase(`\2')')')dnl
define(`capitalize',`patsubst(`$1', `\w+', `capitalize1(`\&')')')dnl
# some specific macros
ifelse(_arc_prog_name_, `milo', `define(_MILO_)', `define(_PANDORA_)')dnl
divert(0)dnl
.\" Written by Ralf Baechle (ralf@waldorf-gmbh.de),
.\"
.\" This is free documentation; you can redistribute it and/or
.\" modify it under the terms of the GNU General Public License as
.\" published by the Free Software Foundation; either version 2 of
.\" the License, or (at your option) any later version.
.\"
.\" The GNU General Public License's references to "object code"
.\" and "executables" are to be interpreted as the output of any
.\" document formatting or typesetting system, including
.\" intermediate and printed output.
.\"
.\" This manual is distributed in the hope that it will be useful,
.\" but WITHOUT ANY WARRANTY; without even the implied warranty of
.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\" GNU General Public License for more details.
.\"
.\" You should have received a copy of the GNU General Public
.\" License along with this manual; if not, write to the Free
.\" Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
.\" USA.
.\"
.TH upcase(_arc_prog_name_) 8 "_release_date_" "Version _prog_version_" ""
.SH NAME
ifelse(_arc_prog_name_, milo, `milo \- Linux/MIPS boot loader', `pandora \- Milo debugging and porting utility')
.SH SYNOPSIS
.B _arc_prog_name_
[
.B \-dv
]
[
.B \-k
.I kernel
]
[
.B \-r
.I image
]
.SH DESCRIPTION
.I capitalize1(_arc_prog_name_)
ifdef(`_MILO_',`is the
.I Linux/MIPS
boot loader for
.I ARC
standard (\c
.I Advanced RISC Computing\c
)
conformant systems.')ifdef(`_PANDORA_',
`is the debugger that formerly was integrated into
.IR Milo .
It'`''`s primary purpose is to help
.I Linux/MIPS
porters to analyse their
.I ARC
conformant systems.')
.SH OPTIONS
.TP
.B -d
Enable additional debug output in
.IR capitalize1(_arc_prog_name_) .
Multiple
.B -d
options increase the debug level and amount of debugging output. When using
.B \-d
.B \-v
is also being set automatically.  This option is only available when
.I capitalize1(_arc_prog_name_)
has been compiled with debugging enabled.
.TP
.B -k kernel
Specify an alternate kernel image to boot. Kernel is a filename in
.I ARC
notation. Default is multi(0)disk(0)fdisk(0)\\VMLINUX or if set, the value
of 
.l ARC
environment variable 
.B MiloDefaultPath
with \\VMLINUX appended. Arguments like A:\\VMLINUX, or C:\\VMLINUX - 
where A: and C: are 
.l ARC
environment variables which expand to a valid
.ARC
pathname prefix - are also supported.
.TP
.B -r image
Load the ramdisk image image and boot kernel with image as root device. Image
is a filename in
.I ARC
notation. Default is no ramdisk image. As for 
.B -k
environment variables are supported.
.TP
.B -v
Run
.I capitalize1(_arc_prog_name_)
in verbose mode.
.I capitalize1(_arc_prog_name_)
will print some statistics about the kernel and the ramdisk image and wait
for a key to be pressed before starting the kernel.
ifdef(`_PANDORA_',`.LP
Once started
.I Pandora
interprets options, then reads and interprets commands from
standard input. Currently the following commands are available:
.TP
.B boot [ kernel ] [ image ]
Exit interactive mode and continue with the normal boot process.
.TP
.B cp0regs
Print the contents of the system control coprocessor'`''`s registers. This
function yet only knows how to handle R4000PC, R4000SC, R4000MC, R4400PC,
R4400SC, R4400MC and R4600.
.TP
.B dump [-bhw] start [end]
Print contents of memory. Output either as bytes, halfwords or as words
maybe selected by the option -b, -h or -w. If the end address is omited
0x100 bytes will be printed.
.TP
.B dumptlb [all] [filename]
Dump the contents of the TLB to the screen.
.I Pandora
dumps all entries pairs of which at least one has it'`''`s V bit set. When
the keyword
.B all
is given
.I Pandora
dumps all entries. When the optional
.B filename
is given
.I Pandora
will write the dump into it instead of the standard output.
.TP
.B fill [-bhw] start [end [val]]
Print contents of memory. Output either as bytes, halfwords or as words
maybe selected by the option -b, -h or -w. If the end address is omited
0x100 bytes will be printed. If val is omited memory will be filled with
zero bytes.
.TP
.B help
Print a short help message with all commands supported in
.IR Pandora .
.TP
.B probe vaddr
.I Pandora
will probe the
CPU'`''`s
.I TLB
and print either the number of the entry used to map the virtual address
or print \"not mapped\".
.TP
.B string start [end]
Dump all printable strings in the memory range from start to end to the
standard output. When end is omited it defaults to start + 0x100.
.TP
.B disasm [-rp] start [end] [filename]
Disasemble memory contents in specified interval. With -r the endianess
of the opcodes read is reversed, -p specify Algorithmics style registers
notation. Disassembled code is written to filename if specified, instead 
of standard output (end must be given in this case). The disassembler code
is under GNU GPL and copyrighted by TERMA Elektronik A/S, Lystrup, Denmark.
.TP
.B quit
Exit
.I Pandora
and return to the
.I ARC
BIOS.
.LP
.SS File name arguments
A
.B Pandora
command'`''`s pathname-type argument is either:
.RS
- a complete
.B ARC
pathname
.RE
.RS
- an
.B ARC
.I filepath
component with a leading reference to an environment 
variable which expands to a valid 
.B ARC
pathname prefix (usually something like A: or C:)
.RE
.RS
- a valid 
.B ARC
.I filepath 
component which is added to
.B Pandora
'`''`s default path. This default path is the value of environment
variable
.B MiloDefaultPath
or multi(0)disk(0)fdisk(0)\\ if it is not set.')
.RE
.SH BUGS
Due to BIOS bugs in various
.I ARC
BIOS implementations the current version of
.I capitalize1(_arc_prog_name_)
doesn't work yet on all
.I ARC
systems.
There is no boot loader for non
.I ARC
conformant systems available. Being based
on
.I ARC
BIOS services
.I Milo
can only support booting from BIOS supported block devices with
.B FAT
or
.B ISO9660
CDROM filesystem.
Network booting via
.I BOOTP
and
.IR TFTP /\c
.I RARP
or 
.IR DLC /\c
.I RIPL
is supported but untested. Booting from tape is untested and not supported
by all firmware implementations. ifdef(`_PANDORA_', `The debugger'`''`s command 
cp0regs should know how to handle all
.I MIPS
CPUs. The disassembler knows only about 
.B R4x00
CPUs.')
.SH "SEE ALSO"
\fBarc\fP(5), \fBbootpd\fP(8), \fBrarp\fP(8), \fBtftpd\fP(8).
