/*
 * milo/vmlinux.c
 *
 * Just a little dummy kernel used for some tests in the beginning.
 * Actually obsolete, but might be useful to start working on new
 * targets.
 *
 */

#include <linux/tty.h>
#include <asm/bootinfo.h>
#include <stand/console.h>
#include <asm/mipsregs.h>
#include <stand/stdio.h>
#include <asm/segment.h>

static char temp[1024];

struct screen_info screen_info = SCREEN_INFO;

unsigned long mips_memory_upper = KSEG0;

/*
 * Parse the tags present in upper memory to find out
 * a pecular one.
 *
 * Parameter: type - tag type to find
 * 
 * returns  : NULL  - failure
 *            !NULL - pointer on the tag structure found 
 *
 * Note: Just a 'prototype', the kernel's one is in 
 *       arch/mips/kernel/setup.c
 *       And well for now - as the date of this release -
 *       they are the same...
 */
tag *
bi_TagFind(enum bi_tag type)
{
  tag* t;
  t = (tag*)(mips_memory_upper - sizeof(tag));
  while((t->tag != tag_dummy) && (t->tag != type))
    {
      t = (tag*)(NEXTTAGPTR(t));
    }
  if (t->tag == tag_dummy)		/* tag not found */
    {
      return (tag*)NULL;
    }
  return t;
}

/*
 * Make a listing of tags available in memory: debug helper,
 * usefull for the use in the dummy 'vmlinux'
 */
void
bi_TagWalk(void)
{
  tag* t;
  int i=0;
  t = (tag*)(mips_memory_upper - sizeof(tag));
  while(t->tag != tag_dummy)
    {
      sprintf(temp,"tag #%02d addr: %08x, type %d, size %u\n", i, (void*)t, t->tag, t->size);
      print_string(temp);
      t = (tag*)(NEXTTAGPTR(t));
      i++;
    }
  return;
}

void kernel_entry(unsigned int a0reg)
{
  /*
   * put anything you might want to test here
   */
/*  int i;*/

  mips_memory_upper=a0reg;

  init_console();

  bi_TagWalk();

/*   for (i=0; i<100; i++) */
/*     { */
/*       sprintf(temp,"Hello World! [%d]\n",i); */
/*       print_string(temp); */
/*     } */
  print_string("Bye-bye World!\n");
  while (1);
}
